const fs = require('fs')
const path = require('path')
const Generator = require('yeoman-generator')

module.exports = class extends Generator {
  constructor(args, opts) {
    // Calling the super constructor is important so our generator is correctly set up
    super(args, opts);

    // Next, add your custom code
    this.option('babel'); // This method adds support for a `--babel` flag
  }

  prompting () {
    this.log(yosay('Welcome to the groundbreaking reactself generator!'));
    return this.prompt([{
      type    : 'input',
      name    : 'name',
      message : 'Your project name: ',
      default : '' // Default to current folder name
    }, {
      type    : 'input',
      name    : 'author',
      message : 'author: ',
      default : '' // Default to current folder name
    }, {
      type    : 'input',
      name    : 'license',
      message : 'license: ',
      default : 'MIT' // Default to current folder name
    }, {
      type    : 'input',
      name    : 'description',
      message : 'description: ',
      default : '' // Default to current folder name
    }, {
      type    : 'input',
      name    : 'repo',
      message : 'git repository: ',
      default : '' // Default to current folder name
    }]).then(answer => {
      this.name = answer.name
      this.author = answer.author
      this.license = answer.license
      this.description = answer.description
      this.repo = answer.repo
    })
  }

  writing () {
    fs.mkdirSync(this.name)
    this.fs.copyTpl(this.templatePath('package.json'), this.destinationPath(`${this.name}/package.json`), {
      name: this.name,
      author: this.author,
      license: this.license,
      description: this.description,
      repo: this.repo
    })
    this.fs.copy(this.templatePath('webpack.config.js'), this.destinationPath(`${this.name}/webpack.config.js`))
    this.fs.copy(this.templatePath('webpack.config.dev.js'), this.destinationPath(`${this.name}/webpack.config.dev.js`))
    this.fs.copy(this.templatePath('src'), this.destinationPath(`${this.name}/src`))
    this.fs.copy(this.templatePath('public'), this.destinationPath(`${this.name}/public`))
  }

  end () {
    this.log(yosay(
        `Your app has been created successfully!
                cd ${this.name} && yarn
        `
    ));
  }
}
